/**
 * Copyright (C) 2010-2012 Agrosense info@agrosense.eu
 *
 * Licensed under the Eclipse Public License - v 1.0 (the "License"); you may
 * not use this file except in compliance with the License. You may obtain a
 * copy of the License at
 *
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
package nl.cloudfarming.client.task.windows;

import java.util.ArrayList;
import java.util.List;
import javax.swing.border.TitledBorder;
import nl.cloudfarming.client.task.Task;
import org.openide.util.Lookup;
import org.openide.util.LookupEvent;
import org.openide.util.LookupListener;

/**
 *
 * @author Maciek Dulkiewicz
 */
public class EntityPanel extends javax.swing.JPanel implements LookupListener {

    private Task task;
    private Lookup.Result entities;
    List<String> entityNames = new ArrayList<>();

    /**
     * Creates new form EntityPanel
     */
    public EntityPanel() {
        initComponents();
    }

    public void setTask(Task task, Class contentClass) {
        this.task = task;
        entities = this.task.getLookup().lookupResult(contentClass);
        entities.addLookupListener(this);
        updateEntities();
    }

    private void updateEntities() {
        entityNames.clear();
        for (Object entity : entities.allInstances()) {
            entityNames.add(entity.toString());
        }
        entityList.setListData(entityNames.toArray());
    }

    public void setBorderTitle(String title) {
        TitledBorder border = (TitledBorder) getBorder();
        border.setTitle(title);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        entityList = new javax.swing.JList();

        setBorder(javax.swing.BorderFactory.createTitledBorder(""));

        jScrollPane1.setViewportView(entityList);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 150, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 200, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JList entityList;
    private javax.swing.JScrollPane jScrollPane1;
    // End of variables declaration//GEN-END:variables

    @Override
    public void resultChanged(LookupEvent ev) {
        updateEntities();
    }
}
